package post.geg;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class Ort {
	
	private Map<Ort,Double> entfMap = new LinkedHashMap<>();
	private String name;
	
	private Ort(String name) {
		this.name = name;
	}

	public double getEntfernungZu(Ort andererOrt) {
		if(!entfMap.containsKey(andererOrt)) return Double.POSITIVE_INFINITY;
		return entfMap.get(andererOrt);
	}
	
	public static List<Ort> getBeispiel() {
		double[][] entf = {
				{0,2,4,2,4},
				{2,0,2,3,5},
				{4,2,0,5,6},
				{2,3,5,0,2},
				{4,5,6,2,0}};
		String[] names = {"A","B","C","D","E"};
		return createOrte(entf,names);
	}
	
	public static List<Ort> getAlleOrte(double[][] entfernung) {
		String[] names = new String[entfernung.length];
		for(int i=0; i<names.length; i++) names[i] = String.format("Ort-%02d", i);
		return createOrte(entfernung,names);
	}

	private static List<Ort> createOrte(double[][] entf, String[] names) {
		List<Ort> alleOrte = new ArrayList<>();		
		for(int i=0; i<names.length; i++) alleOrte.add(new Ort(names[i]));
		for(int i=0; i<names.length; i++) for(int j=0; j<names.length; j++) {
			alleOrte.get(i).entfMap.put(alleOrte.get(j),entf[i][j]);
		}
		return alleOrte;
	}
	
	public String toString() {
		return name;
	}

	public static String printAll(List<Ort> alleOrte) {
		String erg = "";
		for(Ort o : alleOrte) erg += o + ": " + o.entfMap + "\n";
		return erg;
	}

}
